﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Windows.Input;

namespace Lepton_Practical_MVVM_4 {
    class MainWindowViewModel : INotifyPropertyChanged {
        public MainWindowViewModel() {
            FillTestData();
        }

        private void FillTestData() {
            MyItems = new List<MyModel>();
            MyItems.Add(new MyModel() {
                ID = 1,
                Status = MyStatusEnum.OK,
                DocNo = "20130001"
            });
            MyItems.Add(new MyModel() {
                ID = 2,
                Status = MyStatusEnum.Delete,
                DocNo = "20130002"
            });
            MyItems.Add(new MyModel() {
                ID = 3,
                Status = MyStatusEnum.Cancel,
                DocNo = "20130003"
            });
        }

        private List<MyModel> _MyItems;
        /// <summary>
        /// 单据清单
        /// </summary>
        public virtual List<MyModel> MyItems {
            get {
                return _MyItems;
            }
            set {
                _MyItems = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("MyItems"));
            }
        }

        private void ChangeStatus() {
            if (MyItems != null) {
                foreach (var x in MyItems) {
                    if (x.Status != MyStatusEnum.OK) {
                        x.Status = MyStatusEnum.OK;
                    } else {
                        x.Status = MyStatusEnum.Cancel;
                    }
                }
            }
        }
        private MyCommand _ChangeStatusCommand;
        public ICommand ChangeStatusCommand {
            get {
                if (_ChangeStatusCommand == null) {
                    _ChangeStatusCommand = new MyCommand(x => ChangeStatus());
                }
                return _ChangeStatusCommand;
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        class MyCommand : ICommand {

            private Action<object> action;

            public MyCommand(Action<object> action) {
                this.action = action;
            }

            #region ICommand Members

            public bool CanExecute(object parameter) {
                return true;
            }

            public event EventHandler CanExecuteChanged;

            public void Execute(object parameter) {
                action(parameter);
            }

            #endregion
        }
    }
}
