﻿using System.ComponentModel;
using System.Windows.Media;
using System;
using System.Windows.Media.Imaging;

namespace Lepton_Practical_MVVM_4 {

    public class MyModel : INotifyPropertyChanged {

        #region Domain Properties

        private long _ID;
        /// <summary>
        /// 主键
        /// </summary>
        public virtual long ID {
            get {
                return _ID;
            }
            set {
                _ID = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("ID"));
            }
        }

        private MyStatusEnum _Status;
        /// <summary>
        /// 状态
        /// </summary>
        public virtual MyStatusEnum Status {
            get {
                return _Status;
            }
            set {
                _Status = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("Status"));
            }
        }

        private string _DocNo;
        /// <summary>
        /// 单据号
        /// </summary>
        public virtual string DocNo {
            get {
                return _DocNo;
            }
            set {
                _DocNo = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("DocNo"));
            }
        }


        #endregion

        #region INotifyPropertyChanged Members

        public virtual event PropertyChangedEventHandler PropertyChanged;

        #endregion
    }
}
